#include "descriptor/descriptor.h"

int main(void) {

  ITEM	commonattribute,white;
  ITEM 	colonnato1,colonnato2,colonnato3,colonnato4,colonnato5,colonnato6,colonnato7,colonnato8,
  			arco1,arco2,arco3,arco4,floor,pavement,muroleft,muroup,muroright,muroback,
  			scalino1,scalino2,quadro,cornice;
  ITEM	scene;

//				SETTAGGIO LUCI E AMBIENTE

  set_background(0.1,0.1,0.1,TRUE);
  set_ambient_light(0.9,0.9,0.9,0.7);
  create_distant_light(-0.5,-0.5,-0.3,1,1,0.9,1,"Distant");
  create_point_light(2,3,6,1,1,0.9,1,3, "light1");
  create_point_light(2,0,1,1,1,0.9,1.5,10, "light2");
  create_point_light(2,-6,1,1,1,0.9,1.5,5, "light3");
  create_point_light(2,-12,1,1,1,0.9,1.5,5, "light4");
  create_point_light(2,-18,1,1,1,0.9,1.5,5, "light5");
  create_point_light(0,-20,2,1,1,0.9,1.5,20, "light6");

//				ATTRIBUTI

  commonattribute = create_attribute("commonattribute");
  set_color(commonattribute,0.89,0.76,0.65,0.1,0.8);
  set_reflectivity(commonattribute,0.1,10);


  white = create_attribute("white");
  set_color(white,0.95,0.95,0.95,0.2,0.8);
  set_reflectivity(white,0,0);


//				LETTURA OGGETTI DELLA SCENA

  muroleft = read_nurbs("muroleft.db");
  muroup = read_nurbs("muroup.db");
  muroright = read_nurbs("muroright.db");
  muroback=read_nurbs("muroback.db");

  floor = read_nurbs("floor.db");

  pavement= read_nurbs("pavement.db");

  scalino1=read_nurbs("scalino.db");
  scalino2=read_nurbs("scalino.db");

  quadro=read_nurbs("quadro.db");
  cornice=read_nurbs("cornice.db");

  colonnato1 = read_obj("colonnato.obj", "colonnato_1");
  colonnato2 = create_copy(colonnato1, "colonnato_2");
  colonnato3 = create_copy(colonnato1, "colonnato_3");
  colonnato4 = create_copy(colonnato1, "colonnato_4");
  colonnato5 = create_copy(colonnato1, "colonnato_5");
  colonnato6 = create_copy(colonnato1, "colonnato_6");
  colonnato7 = create_copy(colonnato1, "colonnato_7");
  colonnato8 = create_copy(colonnato1, "colonnato_8");

  arco1 = read_obj("arco.obj", "arco_1");
  arco2 = create_copy(arco1, "arco_2");
  arco3 = create_copy(arco1, "arco_3");
  arco4 = create_copy(arco1, "arco_4");


//				TEXTURE MAPPING/SET ATTRIBUTE

  set_attribute(colonnato1,white);
  set_attribute(colonnato2,white);
  set_attribute(colonnato3,white);
  set_attribute(colonnato4,white);
  set_attribute(colonnato5,white);
  set_attribute(colonnato6,white);
  set_attribute(colonnato7,white);
  set_attribute(colonnato8,white);

  set_attribute(arco1,white);
  set_attribute(arco2,white);
  set_attribute(arco3,white);
  set_attribute(arco4,white);
  set_attribute(cornice,commonattribute);

  set_projection_texture(muroright,commonattribute,"textures/wall.hr",1,1,0.5,0.5);
  set_projection_texture(muroup,commonattribute,"textures/wall.hr",1,1,0.5,0.5);
  set_projection_texture(muroleft,commonattribute,"textures/wall.hr",1,1,0.5,0.5);
  set_projection_texture(pavement,white,"textures/pavement.hr",2,0,0.5,1);
  set_projection_texture(floor,commonattribute,"textures/wall.hr",2,1,0.5,0.5);
  set_projection_texture(muroback,commonattribute,"textures/wall.hr",2,1,0.5,0.5);

//				POSIZIONAMENTO OGGETI NELLA SCENA

  set_scale(muroright,1,10,1);
  set_scale(muroup,0.55,10,0.66);
  set_scale(muroleft,1,10,1);
  set_scale(muroback,1.3,1,2);
  set_translate(muroright,0,-12,0);
  set_translate(muroup,3.5,-12,4);
  set_translate(muroleft,4,-12,0);
  set_translate(muroback,5.5,-25,-2.5);
  set_translate(quadro,4.5,-24,-0.5);
  set_translate(cornice,4.5,-24,-0.5);
  set_projection_texture(quadro,white,"textures/galleria.hr",1,2,0.5,0.5);
  set_scale(pavement,1,10,1);
  set_translate(pavement,2,-8,0);

  set_scale(floor,6.5,20,1);
  set_translate(floor,2,-8,-2.1);

  set_translate(scalino2,4,0,0);
  set_translate(colonnato2,4,0,0);
  set_translate(colonnato3,0,-6,0);
  set_translate(colonnato4,4,-6,0);
  set_translate(colonnato5,0,-12,0);
  set_translate(colonnato6,4,-12,0);
  set_translate(colonnato7,0,-18,0);
  set_translate(colonnato8,4,-18,0);

  set_scale(arco1,0.9,0.9,0.9);
  set_translate(arco1,2,-0.2,2.5);
  set_scale(arco2,0.9,0.9,0.9);
  set_translate(arco2,2,-6,2.5);
  set_scale(arco3,0.9,0.9,0.9);
  set_translate(arco3,2,-12,2.5);
  set_scale(arco4,0.9,0.9,0.9);
  set_translate(arco4,2,-18,2.5);

//				CREAZIONE SCENA

  scene = create_list(colonnato1, "scene");
  scene = insert_in_list(scene,colonnato2);
  scene = insert_in_list(scene,colonnato3);
  scene = insert_in_list(scene,colonnato4);
  scene = insert_in_list(scene,colonnato5);
  scene = insert_in_list(scene,colonnato6);
  scene = insert_in_list(scene,colonnato7);
  scene = insert_in_list(scene,colonnato8);
  scene = insert_in_list(scene,arco1);
  scene = insert_in_list(scene,arco2);
  scene = insert_in_list(scene,arco3);
  scene = insert_in_list(scene,arco4);
  scene = insert_in_list(scene,floor);
  scene = insert_in_list(scene,pavement);
  scene = insert_in_list(scene,muroleft);
  scene = insert_in_list(scene,muroup);
  scene = insert_in_list(scene,muroright);
  scene = insert_in_list(scene,muroback);
  scene = insert_in_list(scene,quadro);
  scene = insert_in_list(scene,cornice);
  scene = insert_in_list(scene,scalino1);
  scene = insert_in_list(scene,scalino2);

  save_scene("progetto.md","scene_progetto",scene);
  return(0);
}

